import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React, { useMemo } from 'react';
import classnames from 'classnames';
import uniqueId from 'lodash/uniqueId';
import { parseMetadata } from '@highlight-ui/utils-commons';
import { Typography } from '@highlight-ui/typography';
import styles from './RadioButton.module.scss.js'; // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types

var RadioButtonWithRef = function (_a, ref) {
  var label = _a.label,
      subLabel = _a.subLabel,
      className = _a.className,
      metadata = _a.metadata,
      id = _a.id,
      disabled = _a.disabled,
      radioProps = __rest(_a, ["label", "subLabel", "className", "metadata", "id", "disabled"]);

  var generatedId = useMemo(function () {
    return uniqueId('radioButton-');
  }, []);
  var inputId = id || generatedId;
  return /*#__PURE__*/React.createElement("span", __assign({
    className: classnames(className, styles.radioButton)
  }, parseMetadata(metadata)), /*#__PURE__*/React.createElement("input", __assign({
    ref: ref,
    id: inputId,
    type: "radio",
    disabled: disabled,
    className: styles.radioButtonInput
  }, radioProps)), /*#__PURE__*/React.createElement("label", {
    htmlFor: inputId,
    className: styles.radioButtonLabel
  }, label && /*#__PURE__*/React.createElement(Typography, {
    title: label,
    variant: "body-1",
    component: "span",
    color: disabled ? 'text-disabled' : 'text-default',
    className: styles.radioButtonLabelText
  }, label)), label && subLabel && /*#__PURE__*/React.createElement(Typography, {
    title: subLabel,
    variant: "body-1",
    component: "span",
    color: disabled ? 'text-disabled' : 'text-subdued',
    className: styles.radioButtonSubLabel
  }, subLabel));
};

RadioButtonWithRef.displayName = 'RadioButton';
var RadioButton = /*#__PURE__*/React.forwardRef(RadioButtonWithRef);
export { RadioButton as default };
//# sourceMappingURL=RadioButton.js.map
