import { __assign } from './../external/tslib/tslib.es6.js';
import React, { useMemo } from 'react';
import classnames from 'classnames';
import noop from 'lodash/noop';
import uniqueId from 'lodash/uniqueId';
import { parseMetadata } from '@highlight-ui/utils-commons';
import RadioButton from './RadioButton.js';
import styles from './RadioButtonGroup.module.scss.js'; // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types

var RadioButtonGroupWithRef = function (_a, ref) {
  var _b;

  var className = _a.className,
      metadata = _a.metadata,
      name = _a.name,
      _c = _a.disabled,
      disabled = _c === void 0 ? false : _c,
      _d = _a.orientation,
      orientation = _d === void 0 ? 'vertical' : _d,
      options = _a.options,
      value = _a.value,
      _e = _a.onChange,
      onChange = _e === void 0 ? noop : _e;
  var generatedName = useMemo(function () {
    return uniqueId('radioButtonGroupOption-');
  }, []);
  var radioButtonGroupName = name || generatedName;
  return /*#__PURE__*/React.createElement("div", __assign({
    ref: ref,
    className: classnames(className, styles.radioButtonGroup, (_b = {}, _b[styles.radioButtonGroupHorizontal] = orientation === 'horizontal', _b))
  }, parseMetadata(metadata)), options.map(function (option) {
    return /*#__PURE__*/React.createElement(RadioButton, {
      key: option.value + "-" + radioButtonGroupName,
      metadata: option.metadata,
      className: classnames(option.className, styles.radioButtonGroupOption),
      id: option.id,
      label: option.label,
      subLabel: option.subLabel,
      value: option.value,
      disabled: disabled || option.disabled,
      checked: value === option.value,
      name: radioButtonGroupName,
      onChange: function () {
        return onChange(option);
      }
    });
  }));
};

RadioButtonGroupWithRef.displayName = 'RadioButtonGroup';
var RadioButtonGroup = /*#__PURE__*/React.forwardRef(RadioButtonGroupWithRef);
export { RadioButtonGroup as default };
//# sourceMappingURL=RadioButtonGroup.js.map
